<?php

declare(strict_types=1);

namespace Drupal\navigation_local_tasks\Hook;

use Drupal\Core\Hook\Attribute\Hook;

/**
 * Represents a central place to manage all theme hooks.
 */
class Theme {

  /**
   * Implements hook_theme().
   */
  #[Hook('theme')]
  public function theme($existing, $type, $theme, $path): array {
    return [
      'navigation_local_tasks_details' => [
        'variables' => [
          'title' => NULL,
          'links' => [],
        ],
      ],
      'navigation_local_tasks_actions' => [
        'variables' => [
          'title' => NULL,
          'links' => [],
        ],
      ],
      'block__navigation_local_tasks_actions__preview' => [
        'template' => 'block--navigation-local-tasks-actions--preview',
        'base hook' => 'block',
      ],
    ];
  }

  /**
   * Implement hook_theme_suggestion_alter().
   *
   * Add theme suggestion for the 'actions' block in preview.
   */
  #[Hook('theme_suggestions_alter')]
  public function themeSuggestionsAlter(array &$suggestions, array &$variables, $hook) {
    if ($hook == 'block'
      && $variables['elements']['#plugin_id'] == 'navigation_local_tasks_actions'
      && $variables['elements']['#in_preview']
    ) {
      $suggestions[] = $hook . '__' . $variables['elements']['#plugin_id'] . '__' . 'preview';
    }
  }

}
